Index: kernel/tgb.cc
===================================================================
--- kernel/tgb.cc	(revision a41623dd1e56318466dc81751481d37d19489c7b)
+++ kernel/tgb.cc	(revision 410ea0fb1e22ebcb52e33b6789cf294a2d1f663b)
@@ -3498,30 +3795,32 @@
 #endif
 
-static void shorten_tails(slimgb_alg* c, poly monom)
+static void
+shorten_tails (slimgb_alg * c, poly monom)
 {
   return;
 // BOOLEAN corr=lenS_correct(c->strat);
-  for(int i=0;i<c->n;i++)
+  for (int i = 0; i < c->n; i++)
   {
     //enter tail
 
-    if (c->S->m[i]==NULL) continue;
-    poly tail=c->S->m[i]->next;
-    poly prev=c->S->m[i];
-    BOOLEAN did_something=FALSE;
-    while((tail!=NULL)&& (pLmCmp(tail, monom)>=0))
-    {
-      if (p_LmDivisibleBy(monom,tail,c->r))
-      {
-        did_something=TRUE;
-        prev->next=tail->next;
-        tail->next=NULL;
-        p_Delete(& tail,c->r);
-        tail=prev;
-        //PrintS("Shortened");
-        c->lengths[i]--;
-      }
-      prev=tail;
-      tail=tail->next;
+    if (c->S->m[i] == NULL)
+      continue;
+    poly tail = c->S->m[i]->next;
+    poly prev = c->S->m[i];
+    BOOLEAN did_something = FALSE;
+    while ((tail != NULL) && (pLmCmp (tail, monom) >= 0))
+    {
+      if (p_LmDivisibleBy (monom, tail, c->r))
+      {
+	did_something = TRUE;
+	prev->next = tail->next;
+	tail->next = NULL;
+	p_Delete (&tail, c->r);
+	tail = prev;
+	//PrintS("Shortened");
+	c->lengths[i]--;
+      }
+      prev = tail;
+      tail = tail->next;
     }
     if (did_something)
@@ -3529,124 +3828,129 @@
       int new_pos;
       wlen_type q;
-      q=pQuality(c->S->m[i],c,c->lengths[i]);
-      new_pos=simple_posInS(c->strat,c->S->m[i],c->lengths[i],q);
-
-      int old_pos=-1;
+      q = pQuality (c->S->m[i], c, c->lengths[i]);
+      new_pos = simple_posInS (c->strat, c->S->m[i], c->lengths[i], q);
+
+      int old_pos = -1;
       //assume new_pos<old_pos
-      for (int z=0;z<=c->strat->sl;z++)
-      {
-        if (c->strat->S[z]==c->S->m[i])
-        {
-          old_pos=z;
-          break;
-        }
-      }
-      if (old_pos== -1)
-        for (int z=new_pos-1;z>=0;z--)
-        {
-          if (c->strat->S[z]==c->S->m[i])
-          {
-            old_pos=z;
-            break;
-          }
-        }
-      assume(old_pos>=0);
-      assume(new_pos<=old_pos);
-      assume(pLength(c->strat->S[old_pos])==c->lengths[i]);
-      c->strat->lenS[old_pos]=c->lengths[i];
+      for (int z = 0; z <= c->strat->sl; z++)
+      {
+	if (c->strat->S[z] == c->S->m[i])
+	{
+	  old_pos = z;
+	  break;
+	}
+      }
+      if (old_pos == -1)
+	for (int z = new_pos - 1; z >= 0; z--)
+	{
+	  if (c->strat->S[z] == c->S->m[i])
+	  {
+	    old_pos = z;
+	    break;
+	  }
+	}
+      assume (old_pos >= 0);
+      assume (new_pos <= old_pos);
+      assume (pLength (c->strat->S[old_pos]) == c->lengths[i]);
+      c->strat->lenS[old_pos] = c->lengths[i];
       if (c->strat->lenSw)
-        c->strat->lenSw[old_pos]=q;
-      if (new_pos<old_pos)
-        move_forward_in_S(old_pos,new_pos,c->strat);
-      length_one_crit(c,i,c->lengths[i]);
-    }
-  }
-}
-
-#if 0 // currently unused
-static sorted_pair_node* pop_pair(slimgb_alg* c)
-{
-  clean_top_of_pair_list(c);
-
-  if(c->pair_top<0) return NULL;
-  else return (c->apairs[c->pair_top--]);
-}
-#endif
-
-void slimgb_alg::cleanDegs(int lower, int upper)
-{
-  assume(is_homog);
+	c->strat->lenSw[old_pos] = q;
+      if (new_pos < old_pos)
+	move_forward_in_S (old_pos, new_pos, c->strat);
+      length_one_crit (c, i, c->lengths[i]);
+    }
+  }
+}
+
+#if 0				// currently unused
+static sorted_pair_node *
+pop_pair (slimgb_alg * c)
+{
+  clean_top_of_pair_list (c);
+
+  if (c->pair_top < 0)
+    return NULL;
+  else
+    return (c->apairs[c->pair_top--]);
+}
+#endif
+
+void
+slimgb_alg::cleanDegs (int lower, int upper)
+{
+  assume (is_homog);
   int deg;
   if (TEST_OPT_PROT)
   {
-    PrintS("C");
-  }
-  for(deg=lower;deg<=upper;deg++)
+    PrintS ("C");
+  }
+  for (deg = lower; deg <= upper; deg++)
   {
     int i;
-    for(i=0;i<n;i++)
-    {
-      if (T_deg[i]==deg)
-      {
-          poly h;
-          h=S->m[i];
-          h=redNFTail(h,strat->sl,strat,lengths[i]);
-          if (!rField_is_Zp(r))
-          {
-            p_Cleardenom(h,r);
-            //p_Content(h,r);
-          }
-          else pNorm(h);
-          //TODO:GCD of TERMS
-          poly got=::gcd_of_terms(h,r);
-          p_Delete(&gcd_of_terms[i],r);
-          gcd_of_terms[i]=got;
-          int len=pLength(h);
-          wlen_type wlen=pQuality(h,this,len);
-          if (weighted_lengths)
-            weighted_lengths[i]=wlen;
-          lengths[i]=len;
-          assume(h==S->m[i]);
-          int j;
-          for(j=0;j<=strat->sl;j++)
-          {
-            if (h==strat->S[j])
-            {
-              int new_pos=simple_posInS(strat, h,len, wlen);
-              if (strat->lenS)
-              {
-                strat->lenS[j]=len;
-              }
-              if (strat->lenSw)
-              {
-                strat->lenSw[j]=wlen;
-              }
-              if (new_pos<j)
-              {
-                move_forward_in_S(j,new_pos,strat);
-              }
-              else
-              {
-                if (new_pos>j)
-                 new_pos=new_pos-1;//is identical with one element
-                if (new_pos>j)
-                  move_backward_in_S(j,new_pos,strat);
-              }
-              break;
-            }
-          }
-        }
-    }
-  }
-  {
-    int i,j;
-    for(i=0;i<this->n;i++)
-    {
-      for(j=0;j<i;j++)
-      {
-        if (T_deg[i]+T_deg[j]<=upper)
-        {
-          now_t_rep(i,j,this);
-        }
+    for (i = 0; i < n; i++)
+    {
+      if (T_deg[i] == deg)
+      {
+	poly h;
+	h = S->m[i];
+	h = redNFTail (h, strat->sl, strat, lengths[i]);
+	if (!rField_is_Zp (r))
+	{
+	  p_Cleardenom (h, r);
+	  //p_Content(h,r);
+	}
+	else
+	  pNorm (h);
+	//TODO:GCD of TERMS
+	poly got =::gcd_of_terms (h, r);
+	p_Delete (&gcd_of_terms[i], r);
+	gcd_of_terms[i] = got;
+	int len = pLength (h);
+	wlen_type wlen = pQuality (h, this, len);
+	if (weighted_lengths)
+	  weighted_lengths[i] = wlen;
+	lengths[i] = len;
+	assume (h == S->m[i]);
+	int j;
+	for (j = 0; j <= strat->sl; j++)
+	{
+	  if (h == strat->S[j])
+	  {
+	    int new_pos = simple_posInS (strat, h, len, wlen);
+	    if (strat->lenS)
+	    {
+	      strat->lenS[j] = len;
+	    }
+	    if (strat->lenSw)
+	    {
+	      strat->lenSw[j] = wlen;
+	    }
+	    if (new_pos < j)
+	    {
+	      move_forward_in_S (j, new_pos, strat);
+	    }
+	    else
+	    {
+	      if (new_pos > j)
+		new_pos = new_pos - 1;	//is identical with one element
+	      if (new_pos > j)
+		move_backward_in_S (j, new_pos, strat);
+	    }
+	    break;
+	  }
+	}
+      }
+    }
+  }
+  {
+    int i, j;
+    for (i = 0; i < this->n; i++)
+    {
+      for (j = 0; j < i; j++)
+      {
+	if (T_deg[i] + T_deg[j] <= upper)
+	{
+	  now_t_rep (i, j, this);
+	}
       }
     }
@@ -3656,14 +3960,16 @@
 }
 
-sorted_pair_node* top_pair(slimgb_alg* c)
-{
-  while(c->pair_top>=0)
-  {
-    super_clean_top_of_pair_list(c);//yeah, I know, it's odd that I use a different proc here
-    if ((c->is_homog)&&(c->pair_top>=0)&&(c->apairs[c->pair_top]->deg>=c->lastCleanedDeg+2))
-    {
-      int upper=c->apairs[c->pair_top]->deg-1;
-      c->cleanDegs(c->lastCleanedDeg+1,upper);
-      c->lastCleanedDeg=upper;
+sorted_pair_node *
+top_pair (slimgb_alg * c)
+{
+  while (c->pair_top >= 0)
+  {
+    super_clean_top_of_pair_list (c);	//yeah, I know, it's odd that I use a different proc here
+    if ((c->is_homog) && (c->pair_top >= 0)
+	&& (c->apairs[c->pair_top]->deg >= c->lastCleanedDeg + 2))
+    {
+      int upper = c->apairs[c->pair_top]->deg - 1;
+      c->cleanDegs (c->lastCleanedDeg + 1, upper);
+      c->lastCleanedDeg = upper;
     }
     else
@@ -3673,146 +3979,191 @@
   }
 
-  if(c->pair_top<0) return NULL;
-  else return (c->apairs[c->pair_top]);
-}
-
-sorted_pair_node* quick_pop_pair(slimgb_alg* c)
-{
-  if(c->pair_top<0) return NULL;
-  else return (c->apairs[c->pair_top--]);
-}
-
-static void super_clean_top_of_pair_list(slimgb_alg* c)
-{
-  while((c->pair_top>=0)
-  && (c->apairs[c->pair_top]->i>=0)
-  && (good_has_t_rep(c->apairs[c->pair_top]->j, c->apairs[c->pair_top]->i,c)))
-  {
-    free_sorted_pair_node(c->apairs[c->pair_top],c->r);
+  if (c->pair_top < 0)
+    return NULL;
+  else
+    return (c->apairs[c->pair_top]);
+}
+
+sorted_pair_node *
+quick_pop_pair (slimgb_alg * c)
+{
+  if (c->pair_top < 0)
+    return NULL;
+  else
+    return (c->apairs[c->pair_top--]);
+}
+
+static void
+super_clean_top_of_pair_list (slimgb_alg * c)
+{
+  while ((c->pair_top >= 0)
+	 && (c->apairs[c->pair_top]->i >= 0)
+	 &&
+	 (good_has_t_rep
+	  (c->apairs[c->pair_top]->j, c->apairs[c->pair_top]->i, c)))
+  {
+    free_sorted_pair_node (c->apairs[c->pair_top], c->r);
     c->pair_top--;
   }
 }
 
-void clean_top_of_pair_list(slimgb_alg* c)
-{
-  while((c->pair_top>=0) && (c->apairs[c->pair_top]->i>=0) && (!state_is(UNCALCULATED,c->apairs[c->pair_top]->j, c->apairs[c->pair_top]->i,c)))
-  {
-    free_sorted_pair_node(c->apairs[c->pair_top],c->r);
+void
+clean_top_of_pair_list (slimgb_alg * c)
+{
+  while ((c->pair_top >= 0) && (c->apairs[c->pair_top]->i >= 0)
+	 &&
+	 (!state_is
+	  (UNCALCULATED, c->apairs[c->pair_top]->j, c->apairs[c->pair_top]->i,
+	   c)))
+  {
+    free_sorted_pair_node (c->apairs[c->pair_top], c->r);
     c->pair_top--;
   }
 }
 
-static BOOLEAN state_is(calc_state state, const int & arg_i, const  int & arg_j, slimgb_alg* c)
-{
-  assume(0<=arg_i);
-  assume(0<=arg_j);
-  assume(arg_i<c->n);
-  assume(arg_j<c->n);
-  if (arg_i==arg_j)
+static BOOLEAN
+state_is (calc_state state, const int &arg_i, const int &arg_j,
+	  slimgb_alg * c)
+{
+  assume (0 <= arg_i);
+  assume (0 <= arg_j);
+  assume (arg_i < c->n);
+  assume (arg_j < c->n);
+  if (arg_i == arg_j)
   {
     return (TRUE);
   }
-  if (arg_i>arg_j)
-  {
-    return (c->states[arg_i][arg_j]==state);
-  }
-  else return(c->states[arg_j][arg_i]==state);
-}
-
-void free_sorted_pair_node(sorted_pair_node* s, ring r)
-{
-  if (s->i>=0)
-    p_Delete(&s->lcm_of_lm,r);
-  omfree(s);
-}
-
-static BOOLEAN pair_better(sorted_pair_node* a,sorted_pair_node* b, slimgb_alg* c)
-{
-  if (a->deg<b->deg) return TRUE;
-  if (a->deg>b->deg) return FALSE;
-
-  int comp=pLmCmp(a->lcm_of_lm, b->lcm_of_lm);
-  if (comp==1) return FALSE;
-  if (-1==comp) return TRUE;
-  if (a->expected_length<b->expected_length) return TRUE;
-  if (a->expected_length>b->expected_length) return FALSE;
-  if (a->i+a->j<b->i+b->j) return TRUE;
-   if (a->i+a->j>b->i+b->j) return FALSE;
-  if (a->i<b->i) return TRUE;
-  if (a->i>b->i) return FALSE;
+  if (arg_i > arg_j)
+  {
+    return (c->states[arg_i][arg_j] == state);
+  }
+  else
+    return (c->states[arg_j][arg_i] == state);
+}
+
+void
+free_sorted_pair_node (sorted_pair_node * s, ring r)
+{
+  if (s->i >= 0)
+    p_Delete (&s->lcm_of_lm, r);
+  omfree (s);
+}
+
+static BOOLEAN
+pair_better (sorted_pair_node * a, sorted_pair_node * b, slimgb_alg * c)
+{
+  if (a->deg < b->deg)
+    return TRUE;
+  if (a->deg > b->deg)
+    return FALSE;
+
+  int comp = pLmCmp (a->lcm_of_lm, b->lcm_of_lm);
+  if (comp == 1)
+    return FALSE;
+  if (-1 == comp)
+    return TRUE;
+  if (a->expected_length < b->expected_length)
+    return TRUE;
+  if (a->expected_length > b->expected_length)
+    return FALSE;
+  if (a->i + a->j < b->i + b->j)
+    return TRUE;
+  if (a->i + a->j > b->i + b->j)
+    return FALSE;
+  if (a->i < b->i)
+    return TRUE;
+  if (a->i > b->i)
+    return FALSE;
   return TRUE;
 }
 
-static int tgb_pair_better_gen(const void* ap,const void* bp)
-{
-  sorted_pair_node* a=*((sorted_pair_node**)ap);
-  sorted_pair_node* b=*((sorted_pair_node**)bp);
-  assume((a->i>a->j) || (a->i < 0));
-  assume((b->i>b->j) || (b->i < 0));
-  if (a->deg<b->deg) return -1;
-  if (a->deg>b->deg) return 1;
-
- int comp=pLmCmp(a->lcm_of_lm, b->lcm_of_lm);
-
-  if (comp==1) return 1;
-  if (-1==comp) return -1;
-   if (a->expected_length<b->expected_length) return -1;
-  if (a->expected_length>b->expected_length) return 1;
-  if (a->i+a->j<b->i+b->j) return -1;
-   if (a->i+a->j>b->i+b->j) return 1;
-  if (a->i<b->i) return -1;
-   if (a->i>b->i) return 1;
+static int
+tgb_pair_better_gen (const void *ap, const void *bp)
+{
+  sorted_pair_node *a = *((sorted_pair_node **) ap);
+  sorted_pair_node *b = *((sorted_pair_node **) bp);
+  assume ((a->i > a->j) || (a->i < 0));
+  assume ((b->i > b->j) || (b->i < 0));
+  if (a->deg < b->deg)
+    return -1;
+  if (a->deg > b->deg)
+    return 1;
+
+  int comp = pLmCmp (a->lcm_of_lm, b->lcm_of_lm);
+
+  if (comp == 1)
+    return 1;
+  if (-1 == comp)
+    return -1;
+  if (a->expected_length < b->expected_length)
+    return -1;
+  if (a->expected_length > b->expected_length)
+    return 1;
+  if (a->i + a->j < b->i + b->j)
+    return -1;
+  if (a->i + a->j > b->i + b->j)
+    return 1;
+  if (a->i < b->i)
+    return -1;
+  if (a->i > b->i)
+    return 1;
   return 0;
 }
 
-static poly gcd_of_terms(poly p, ring r)
-{
-  int max_g_0=0;
-  assume(p!=NULL);
+static poly
+gcd_of_terms (poly p, ring r)
+{
+  int max_g_0 = 0;
+  assume (p != NULL);
   int i;
-  poly m=pOne();
+  poly m = pOne ();
   poly t;
-  for (i=pVariables; i; i--)
-  {
-      pSetExp(m,i, pGetExp(p,i));
-      if (max_g_0==0)
-  if (pGetExp(m,i)>0)
-    max_g_0=i;
-  }
-
-  t=p->next;
-  while (t!=NULL)
-  {
-    if (max_g_0==0) break;
-    for (i=max_g_0; i; i--)
-    {
-      pSetExp(m,i, si_min(pGetExp(t,i),pGetExp(m,i)));
-      if (max_g_0==i)
-  if (pGetExp(m,i)==0)
-    max_g_0=0;
-      if ((max_g_0==0) && (pGetExp(m,i)>0))
-      {
-  max_g_0=i;
-      }
-    }
-    t=t->next;
-  }
-  p_Setm(m,r);
-  if (max_g_0>0)
+  for (i = pVariables; i; i--)
+  {
+    pSetExp (m, i, pGetExp (p, i));
+    if (max_g_0 == 0)
+      if (pGetExp (m, i) > 0)
+	max_g_0 = i;
+  }
+
+  t = p->next;
+  while (t != NULL)
+  {
+    if (max_g_0 == 0)
+      break;
+    for (i = max_g_0; i; i--)
+    {
+      pSetExp (m, i, si_min (pGetExp (t, i), pGetExp (m, i)));
+      if (max_g_0 == i)
+	if (pGetExp (m, i) == 0)
+	  max_g_0 = 0;
+      if ((max_g_0 == 0) && (pGetExp (m, i) > 0))
+      {
+	max_g_0 = i;
+      }
+    }
+    t = t->next;
+  }
+  p_Setm (m, r);
+  if (max_g_0 > 0)
     return m;
-  pDelete(&m);
+  pDelete (&m);
   return NULL;
 }
 
-static inline BOOLEAN pHasNotCFExtended(poly p1, poly p2, poly m)
-{
-
-  if (pGetComp(p1) > 0 || pGetComp(p2) > 0)
+static inline BOOLEAN
+pHasNotCFExtended (poly p1, poly p2, poly m)
+{
+
+  if (pGetComp (p1) > 0 || pGetComp (p2) > 0)
     return FALSE;
   int i = 1;
   loop
   {
-    if ((pGetExp(p1, i)-pGetExp(m,i) >0) && (pGetExp(p2, i) -pGetExp(m,i)> 0))   return FALSE;
-    if (i == pVariables)                                return TRUE;
+    if ((pGetExp (p1, i) - pGetExp (m, i) > 0)
+	&& (pGetExp (p2, i) - pGetExp (m, i) > 0))
+      return FALSE;
+    if (i == pVariables)
+      return TRUE;
     i++;
   }
@@ -3820,53 +4171,62 @@
 
 //for impl reasons may return false if the the normal product criterion matches
-static inline BOOLEAN extended_product_criterion(poly p1, poly gcd1, poly p2, poly gcd2, slimgb_alg* c)
+static inline BOOLEAN
+extended_product_criterion (poly p1, poly gcd1, poly p2, poly gcd2,
+			    slimgb_alg * c)
 {
   if (c->nc)
     return FALSE;
-  if(gcd1==NULL) return FALSE;
-        if(gcd2==NULL) return FALSE;
-        gcd1->next=gcd2; //may ordered incorrect
-        poly m=gcd_of_terms(gcd1,c->r);
-        gcd1->next=NULL;
-        if (m==NULL) return FALSE;
-
-        BOOLEAN erg=pHasNotCFExtended(p1,p2,m);
-        pDelete(&m);
-        return erg;
-}
-
-#if 0 //currently unused
-static poly kBucketGcd(kBucket* b, ring r)
-{
-  int s=0;
+  if (gcd1 == NULL)
+    return FALSE;
+  if (gcd2 == NULL)
+    return FALSE;
+  gcd1->next = gcd2;		//may ordered incorrect
+  poly m = gcd_of_terms (gcd1, c->r);
+  gcd1->next = NULL;
+  if (m == NULL)
+    return FALSE;
+
+  BOOLEAN erg = pHasNotCFExtended (p1, p2, m);
+  pDelete (&m);
+  return erg;
+}
+
+#if 0				//currently unused
+static poly
+kBucketGcd (kBucket * b, ring r)
+{
+  int s = 0;
   int i;
   poly m, n;
-  BOOLEAN initialized=FALSE;
-  for (i=MAX_BUCKET-1;i>=0;i--)
-  {
-    if (b->buckets[i]!=NULL)
+  BOOLEAN initialized = FALSE;
+  for (i = MAX_BUCKET - 1; i >= 0; i--)
+  {
+    if (b->buckets[i] != NULL)
     {
       if (!initialized)
       {
-  m=gcd_of_terms(b->buckets[i],r);
-  initialized=TRUE;
-  if (m==NULL) return NULL;
+	m = gcd_of_terms (b->buckets[i], r);
+	initialized = TRUE;
+	if (m == NULL)
+	  return NULL;
       }
       else
-  {
-    n=gcd_of_terms(b->buckets[i],r);
-    if (n==NULL) {
-      pDelete(&m);
-      return NULL;
-    }
-    n->next=m;
-    poly t=gcd_of_terms(n,r);
-    n->next=NULL;
-    pDelete(&m);
-    pDelete(&n);
-    m=t;
-    if (m==NULL) return NULL;
-
-  }
+      {
+	n = gcd_of_terms (b->buckets[i], r);
+	if (n == NULL)
+	{
+	  pDelete (&m);
+	  return NULL;
+	}
+	n->next = m;
+	poly t = gcd_of_terms (n, r);
+	n->next = NULL;
+	pDelete (&m);
+	pDelete (&n);
+	m = t;
+	if (m == NULL)
+	  return NULL;
+
+      }
     }
   }
@@ -3875,34 +4235,39 @@
 #endif
 
-static inline wlen_type quality_of_pos_in_strat_S(int pos, slimgb_alg* c)
-{
-  if (c->strat->lenSw!=NULL) return c->strat->lenSw[pos];
+static inline wlen_type
+quality_of_pos_in_strat_S (int pos, slimgb_alg * c)
+{
+  if (c->strat->lenSw != NULL)
+    return c->strat->lenSw[pos];
   return c->strat->lenS[pos];
 }
 
 #ifdef HAVE_PLURAL
-static inline wlen_type quality_of_pos_in_strat_S_mult_high(int pos, poly high, slimgb_alg* c)
+static inline wlen_type
+quality_of_pos_in_strat_S_mult_high (int pos, poly high, slimgb_alg * c)
   //meant only for nc
 {
-  poly m=pOne();
-  pExpVectorDiff(m,high ,c->strat->S[pos]);
-  poly product = nc_mm_Mult_pp(m, c->strat->S[pos], c->r);
-  wlen_type erg=pQuality(product,c);
-  pDelete(&m);
-  pDelete(&product);
+  poly m = pOne ();
+  pExpVectorDiff (m, high, c->strat->S[pos]);
+  poly product = nc_mm_Mult_pp (m, c->strat->S[pos], c->r);
+  wlen_type erg = pQuality (product, c);
+  pDelete (&m);
+  pDelete (&product);
   return erg;
 }
 #endif
 
-static void multi_reduction_lls_trick(red_object* los, int losl,slimgb_alg* c,find_erg & erg)
-{
-  erg.expand=NULL;
-  BOOLEAN swap_roles; //from reduce_by, to_reduce_u if fromS
-  if(erg.fromS)
-  {
-    if(pLmEqual(c->strat->S[erg.reduce_by],los[erg.to_reduce_u].p))
-    {
-      wlen_type quality_a=quality_of_pos_in_strat_S(erg.reduce_by,c);
-      int best=erg.to_reduce_u+1;
+static void
+multi_reduction_lls_trick (red_object * los, int losl, slimgb_alg * c,
+			   find_erg & erg)
+{
+  erg.expand = NULL;
+  BOOLEAN swap_roles;		//from reduce_by, to_reduce_u if fromS
+  if (erg.fromS)
+  {
+    if (pLmEqual (c->strat->S[erg.reduce_by], los[erg.to_reduce_u].p))
+    {
+      wlen_type quality_a = quality_of_pos_in_strat_S (erg.reduce_by, c);
+      int best = erg.to_reduce_u + 1;
 /*
       for (i=erg.to_reduce_u;i>=erg.to_reduce_l;i--)
@@ -3918,200 +4283,205 @@
       {*/
       wlen_type qc;
-      best=find_best(los,erg.to_reduce_l,erg.to_reduce_u,qc,c);
-      if(qc<quality_a)
-      {
-  los[best].flatten();
-  int b_pos=kBucketCanonicalize(los[best].bucket);
-  los[best].p=los[best].bucket->buckets[b_pos];
-  qc=pQuality(los[best].bucket->buckets[b_pos],c);
-  if(qc<quality_a)
-  {
-    red_object h=los[erg.to_reduce_u];
-    los[erg.to_reduce_u]=los[best];
-    los[best]=h;
-    swap_roles=TRUE;
+      best = find_best (los, erg.to_reduce_l, erg.to_reduce_u, qc, c);
+      if (qc < quality_a)
+      {
+	los[best].flatten ();
+	int b_pos = kBucketCanonicalize (los[best].bucket);
+	los[best].p = los[best].bucket->buckets[b_pos];
+	qc = pQuality (los[best].bucket->buckets[b_pos], c);
+	if (qc < quality_a)
+	{
+	  red_object h = los[erg.to_reduce_u];
+	  los[erg.to_reduce_u] = los[best];
+	  los[best] = h;
+	  swap_roles = TRUE;
+	}
+	else
+	  swap_roles = FALSE;
+      }
+      else
+      {
+	swap_roles = FALSE;
+      }
+    }
+    else
+    {
+      if (erg.to_reduce_u > erg.to_reduce_l)
+      {
+	wlen_type quality_a = quality_of_pos_in_strat_S (erg.reduce_by, c);
+#ifdef HAVE_PLURAL
+	if ((c->nc) && (!(rIsSCA (c->r))))
+	  quality_a =
+	    quality_of_pos_in_strat_S_mult_high (erg.reduce_by,
+						 los[erg.to_reduce_u].p, c);
+#endif
+	int best = erg.to_reduce_u + 1;
+	wlen_type qc;
+	best = find_best (los, erg.to_reduce_l, erg.to_reduce_u, qc, c);
+	assume (qc == los[best].guess_quality (c));
+	if (qc < quality_a)
+	{
+	  los[best].flatten ();
+	  int b_pos = kBucketCanonicalize (los[best].bucket);
+	  los[best].p = los[best].bucket->buckets[b_pos];
+	  qc = pQuality (los[best].bucket->buckets[b_pos], c);
+	  //(best!=erg.to_reduce_u+1)
+	  if (qc < quality_a)
+	  {
+	    red_object h = los[erg.to_reduce_u];
+	    los[erg.to_reduce_u] = los[best];
+	    los[best] = h;
+	    erg.reduce_by = erg.to_reduce_u;
+	    erg.fromS = FALSE;
+	    erg.to_reduce_u--;
+	  }
+	}
+      }
+      else
+      {
+	assume (erg.to_reduce_u == erg.to_reduce_l);
+	wlen_type quality_a = quality_of_pos_in_strat_S (erg.reduce_by, c);
+	wlen_type qc = los[erg.to_reduce_u].guess_quality (c);
+	if (qc < 0)
+	  PrintS ("Wrong wlen_type");
+	if (qc < quality_a)
+	{
+	  int best = erg.to_reduce_u;
+	  los[best].flatten ();
+	  int b_pos = kBucketCanonicalize (los[best].bucket);
+	  los[best].p = los[best].bucket->buckets[b_pos];
+	  qc = pQuality (los[best].bucket->buckets[b_pos], c);
+	  assume (qc >= 0);
+	  if (qc < quality_a)
+	  {
+	    BOOLEAN exp = FALSE;
+	    if (qc <= 2)
+	    {
+	      //Print("\n qc is %lld \n",qc);
+	      exp = TRUE;
+	    }
+	    else
+	    {
+	      if (qc < quality_a / 2)
+		exp = TRUE;
+	      else if (erg.reduce_by < c->n / 4)
+		exp = TRUE;
+	    }
+	    if (exp)
+	    {
+	      poly clear_into;
+	      los[erg.to_reduce_u].flatten ();
+	      kBucketClear (los[erg.to_reduce_u].bucket, &clear_into,
+			    &erg.expand_length);
+	      erg.expand = pCopy (clear_into);
+	      kBucketInit (los[erg.to_reduce_u].bucket, clear_into,
+			   erg.expand_length);
+	      if (TEST_OPT_PROT)
+		PrintS ("e");
+	    }
+	  }
+	}
+      }
+
+      swap_roles = FALSE;
+      return;
+    }
   }
   else
-    swap_roles=FALSE;
-      }
-      else
-      {
-  swap_roles=FALSE;
-      }
-    }
-      else
-    {
-      if (erg.to_reduce_u>erg.to_reduce_l)
-      {
-  wlen_type quality_a=quality_of_pos_in_strat_S(erg.reduce_by,c);
-  #ifdef HAVE_PLURAL
-  if ((c->nc) && (!(rIsSCA(c->r))))
-    quality_a=quality_of_pos_in_strat_S_mult_high(erg.reduce_by, los[erg.to_reduce_u].p, c);
-  #endif
-  int best=erg.to_reduce_u+1;
-  wlen_type qc;
-  best=find_best(los,erg.to_reduce_l,erg.to_reduce_u,qc,c);
-  assume(qc==los[best].guess_quality(c));
-  if(qc<quality_a)
-  {
-    los[best].flatten();
-    int b_pos=kBucketCanonicalize(los[best].bucket);
-    los[best].p=los[best].bucket->buckets[b_pos];
-    qc=pQuality(los[best].bucket->buckets[b_pos],c);
-    //(best!=erg.to_reduce_u+1)
-    if(qc<quality_a)
-    {
-    red_object h=los[erg.to_reduce_u];
-    los[erg.to_reduce_u]=los[best];
-    los[best]=h;
-    erg.reduce_by=erg.to_reduce_u;
-    erg.fromS=FALSE;
-    erg.to_reduce_u--;
-    }
-  }
-      }
-      else
-      {
-  assume(erg.to_reduce_u==erg.to_reduce_l);
-  wlen_type quality_a=
-        quality_of_pos_in_strat_S(erg.reduce_by,c);
-  wlen_type qc=los[erg.to_reduce_u].guess_quality(c);
-  if (qc<0) PrintS("Wrong wlen_type");
-  if(qc<quality_a)
-  {
-    int best=erg.to_reduce_u;
-    los[best].flatten();
-    int b_pos=kBucketCanonicalize(los[best].bucket);
-    los[best].p=los[best].bucket->buckets[b_pos];
-    qc=pQuality(los[best].bucket->buckets[b_pos],c);
-    assume(qc>=0);
-    if(qc<quality_a)
-    {
-      BOOLEAN exp=FALSE;
-      if(qc<=2)
-      {
-         //Print("\n qc is %lld \n",qc);
-         exp=TRUE;
-      }
-      else
-      {
-         if (qc<quality_a/2)
-          exp=TRUE;
-         else
-       if(erg.reduce_by<c->n/4)
-          exp=TRUE;
-      }
-      if (exp)
-      {
-        poly clear_into;
-        los[erg.to_reduce_u].flatten();
-        kBucketClear(los[erg.to_reduce_u].bucket,&clear_into,&erg.expand_length);
-        erg.expand=pCopy(clear_into);
-        kBucketInit(los[erg.to_reduce_u].bucket,clear_into,erg.expand_length);
-        if (TEST_OPT_PROT)
-    PrintS("e");
-      }
-    }
-  }
-      }
-
-      swap_roles=FALSE;
+  {
+    if (erg.reduce_by > erg.to_reduce_u)
+    {
+      //then lm(rb)>= lm(tru) so =
+      assume (erg.reduce_by == erg.to_reduce_u + 1);
+      int best = erg.reduce_by;
+      wlen_type quality_a = los[erg.reduce_by].guess_quality (c);
+      wlen_type qc;
+      best = find_best (los, erg.to_reduce_l, erg.to_reduce_u, qc, c);
+
+      if (qc < quality_a)
+      {
+	red_object h = los[erg.reduce_by];
+	los[erg.reduce_by] = los[best];
+	los[best] = h;
+      }
+      swap_roles = FALSE;
       return;
-      }
-  }
-  else
-  {
-    if(erg.reduce_by>erg.to_reduce_u)
-    {
-      //then lm(rb)>= lm(tru) so =
-      assume(erg.reduce_by==erg.to_reduce_u+1);
-      int best=erg.reduce_by;
-      wlen_type quality_a=los[erg.reduce_by].guess_quality(c);
-      wlen_type qc;
-      best=find_best(los,erg.to_reduce_l,erg.to_reduce_u,qc,c);
-
-      if(qc<quality_a)
-      {
-    red_object h=los[erg.reduce_by];
-    los[erg.reduce_by]=los[best];
-    los[best]=h;
-  }
-  swap_roles=FALSE;
-  return;
     }
     else
     {
-      assume(!pLmEqual(los[erg.reduce_by].p,los[erg.to_reduce_l].p));
-      assume(erg.to_reduce_u==erg.to_reduce_l);
+      assume (!pLmEqual (los[erg.reduce_by].p, los[erg.to_reduce_l].p));
+      assume (erg.to_reduce_u == erg.to_reduce_l);
       //further assume, that reduce_by is the above all other polys
       //with same leading term
-      int il=erg.reduce_by;
-      wlen_type quality_a =los[erg.reduce_by].guess_quality(c);
+      int il = erg.reduce_by;
+      wlen_type quality_a = los[erg.reduce_by].guess_quality (c);
       wlen_type qc;
-      while((il>0) && pLmEqual(los[il-1].p,los[il].p))
-      {
-  il--;
-  qc=los[il].guess_quality(c);
-  if (qc<quality_a)
-  {
-    quality_a=qc;
-    erg.reduce_by=il;
-  }
-      }
-      swap_roles=FALSE;
-    }
-  }
-  if(swap_roles)
+      while ((il > 0) && pLmEqual (los[il - 1].p, los[il].p))
+      {
+	il--;
+	qc = los[il].guess_quality (c);
+	if (qc < quality_a)
+	{
+	  quality_a = qc;
+	  erg.reduce_by = il;
+	}
+      }
+      swap_roles = FALSE;
+    }
+  }
+  if (swap_roles)
   {
     if (TEST_OPT_PROT)
-      PrintS("b");
+      PrintS ("b");
     poly clear_into;
     int new_length;
-    int bp=erg.to_reduce_u;//bucket_positon
+    int bp = erg.to_reduce_u;	//bucket_positon
     //kBucketClear(los[bp].bucket,&clear_into,&new_length);
-    new_length=los[bp].clear_to_poly();
-    clear_into=los[bp].p;
-    poly p=c->strat->S[erg.reduce_by];
-    int j=erg.reduce_by;
-    int old_length=c->strat->lenS[j];// in view of S
-    los[bp].p=p;
+    new_length = los[bp].clear_to_poly ();
+    clear_into = los[bp].p;
+    poly p = c->strat->S[erg.reduce_by];
+    int j = erg.reduce_by;
+    int old_length = c->strat->lenS[j];	// in view of S
+    los[bp].p = p;
     if (c->eliminationProblem)
     {
-        los[bp].sugar=c->pTotaldegree_full(p);
-    }
-    kBucketInit(los[bp].bucket,p,old_length);
-    wlen_type qal=pQuality(clear_into,c,new_length);
-    int pos_in_c=-1;
+      los[bp].sugar = c->pTotaldegree_full (p);
+    }
+    kBucketInit (los[bp].bucket, p, old_length);
+    wlen_type qal = pQuality (clear_into, c, new_length);
+    int pos_in_c = -1;
     int z;
     int new_pos;
-    new_pos=simple_posInS(c->strat,clear_into,new_length, qal);
-    assume(new_pos<=j);
-    for (z=c->n;z;z--)
-    {
-      if(p==c->S->m[z-1])
-      {
-  pos_in_c=z-1;
-  break;
-      }
-    }
-
-    int tdeg_full=-1;
-    int tdeg=-1;
-    if(pos_in_c>=0)
-    {
-      #ifdef TGB_RESORT_PAIRS
-      c->used_b=TRUE;
-      c->replaced[pos_in_c]=TRUE;
-      #endif
-      tdeg=c->T_deg[pos_in_c];
-      c->S->m[pos_in_c]=clear_into;
-      c->lengths[pos_in_c]=new_length;
-      c->weighted_lengths[pos_in_c]=qal;
-      if (c->gcd_of_terms[pos_in_c]==NULL)
-        c->gcd_of_terms[pos_in_c]=gcd_of_terms(clear_into,c->r);
+    new_pos = simple_posInS (c->strat, clear_into, new_length, qal);
+    assume (new_pos <= j);
+    for (z = c->n; z; z--)
+    {
+      if (p == c->S->m[z - 1])
+      {
+	pos_in_c = z - 1;
+	break;
+      }
+    }
+
+    int tdeg_full = -1;
+    int tdeg = -1;
+    if (pos_in_c >= 0)
+    {
+#ifdef TGB_RESORT_PAIRS
+      c->used_b = TRUE;
+      c->replaced[pos_in_c] = TRUE;
+#endif
+      tdeg = c->T_deg[pos_in_c];
+      c->S->m[pos_in_c] = clear_into;
+      c->lengths[pos_in_c] = new_length;
+      c->weighted_lengths[pos_in_c] = qal;
+      if (c->gcd_of_terms[pos_in_c] == NULL)
+	c->gcd_of_terms[pos_in_c] = gcd_of_terms (clear_into, c->r);
       if (c->T_deg_full)
-        tdeg_full=c->T_deg_full[pos_in_c]=c->pTotaldegree_full(clear_into);
-      else tdeg_full=tdeg;
-      c_S_element_changed_hook(pos_in_c,c);
+	tdeg_full = c->T_deg_full[pos_in_c] =
+	  c->pTotaldegree_full (clear_into);
+      else
+	tdeg_full = tdeg;
+      c_S_element_changed_hook (pos_in_c, c);
     }
     else
